searchData={"items":[{"type":"module","title":"Membrane.FFmpeg.SWScale.Converter","doc":"This element performs video scaling and conversion between pixel formats of raw video, using SWScale module of FFmpeg library.\n\nFollowing options that can be specified when creating Scaler:\n- `format` - desired pixel format of the output video.\n- `output_width` - desired scaled video width. Needs to be an even number.\n- `output_height` - desired scaled video height. Needs to be an even number.\n- `use_shm?` - indicator if native scaler will use shared memory (via `t:Shmex.t/0`) for storing frames. Default to false.\n\nOnly the following pixel formats are supported, both as input and output:\n- I420\n- I422\n- I444\n- RGB\n- BGRA\n- RGBA\n- NV12\n- NV21\n- AYUV\n- YUY2\n\nIf `format` is not specyfied, output video will have the same format as input.\n\nIf neither `output_width` nor `output_height` is specyfied, video frames will not be scaled.\n\nIf only one dimension is specified (either `output_width` or `output_height`), the other dimension is calculated on `handle_stream_format` callback based on input dimensions.\n\nScaling consists of two operations:\n- scaling itself - resizing video frame with keeping original ratio. After that operation at least one of the dimensions of the input frame match the respective dimension of the desired output size. The second one (if does not match) is smaller than its respective dimension.\n- adding paddings - if one dimension does not match after scaling, paddings have to be added. They are put on both sides of the scaled frame equally. They are either above and below the frame or on the left and right sides of it. It depends on the dimension that did not match after scaling.\n\nMembrane.FFmpeg.SWScale.Converter requires getting stream format with input video width and height. To meet all requirements either `Membrane.Element.RawVideo.Parser` or some decoder (e.g. `Membrane.H264.FFmpeg.Decoder`) have to precede Membrane.FFmpeg.SWScale.Converter in the pipeline.","ref":"Membrane.FFmpeg.SWScale.Converter.html"},{"type":"module","title":"Element options - Membrane.FFmpeg.SWScale.Converter","doc":"Passed via struct `t:Membrane.FFmpeg.SWScale.Converter.t/0`\n\n- `output_width`  \n\n  ```\n  non_neg_integer() | nil\n  ```\n  \n  Default value: `nil`  \n  Width of the scaled video.\n\n\n- `output_height`  \n\n  ```\n  non_neg_integer() | nil\n  ```\n  \n  Default value: `nil`  \n  Height of the scaled video.\n\n\n\n- `use_shm?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `false`  \n  If true, native scaler will use shared memory (via `t:Shmex.t/0`) for storing frames\n\n\n\n- `format`  \n\n  ```\n  RawVideo.pixel_format() | nil\n  ```\n  \n  Default value: `nil`  \n  Desired pixel format of output video.","ref":"Membrane.FFmpeg.SWScale.Converter.html#module-element-options"},{"type":"module","title":"Pads - Membrane.FFmpeg.SWScale.Converter","doc":"### `:input`\n\nAccepted formats:\n```\n%RawVideo{aligned: true, pixel_format: pixel_format} when pixel_format in @supported_pixel_formats\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\n\n\n### `:output`\n\nAccepted formats:\n```\n%RawVideo{aligned: true, pixel_format: pixel_format} when pixel_format in @supported_pixel_formats\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:auto`","ref":"Membrane.FFmpeg.SWScale.Converter.html#module-pads"},{"type":"function","title":"Membrane.FFmpeg.SWScale.Converter.options/0","doc":"Returns description of options available for this module","ref":"Membrane.FFmpeg.SWScale.Converter.html#options/0"},{"type":"type","title":"Membrane.FFmpeg.SWScale.Converter.t/0","doc":"Struct containing options for `Membrane.FFmpeg.SWScale.Converter`","ref":"Membrane.FFmpeg.SWScale.Converter.html#t:t/0"},{"type":"module","title":"Membrane.FFmpeg.SWScale.PixelFormatConverter","doc":"This module is deprecated. Use Membrane.FFmpeg.SWScale.Converter instead.\n\nAll options supported by Membrane.FFmpeg.SWScale.PixelFormatConverter are supported by Membrane.FFmpeg.SWScale.Converter.","ref":"Membrane.FFmpeg.SWScale.PixelFormatConverter.html"},{"type":"module","title":"Element options - Membrane.FFmpeg.SWScale.PixelFormatConverter","doc":"Passed via struct `t:Membrane.FFmpeg.SWScale.PixelFormatConverter.t/0`\n\n- `format`  \n\n  ```\n  RawVideo.pixel_format()\n  ```\n  \n  ***Required***  \n  Desired pixel format of output video.","ref":"Membrane.FFmpeg.SWScale.PixelFormatConverter.html#module-element-options"},{"type":"module","title":"Pads - Membrane.FFmpeg.SWScale.PixelFormatConverter","doc":"### `:input`\n\nAccepted formats:\n```\n%RawVideo{aligned: true, pixel_format: pixel_format} when pixel_format in @supported_pixel_formats\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\n\n\n### `:output`\n\nAccepted formats:\n```\n%RawVideo{aligned: true, pixel_format: pixel_format} when pixel_format in @supported_pixel_formats\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:auto`","ref":"Membrane.FFmpeg.SWScale.PixelFormatConverter.html#module-pads"},{"type":"function","title":"Membrane.FFmpeg.SWScale.PixelFormatConverter.options/0","doc":"Returns description of options available for this module","ref":"Membrane.FFmpeg.SWScale.PixelFormatConverter.html#options/0"},{"type":"function","title":"Membrane.FFmpeg.SWScale.PixelFormatConverter.supported_pixel_formats/0","doc":"","ref":"Membrane.FFmpeg.SWScale.PixelFormatConverter.html#supported_pixel_formats/0"},{"type":"type","title":"Membrane.FFmpeg.SWScale.PixelFormatConverter.t/0","doc":"Struct containing options for `Membrane.FFmpeg.SWScale.PixelFormatConverter`","ref":"Membrane.FFmpeg.SWScale.PixelFormatConverter.html#t:t/0"},{"type":"module","title":"Membrane.FFmpeg.SWScale.Scaler","doc":"This module is deprecated. Use Membrane.FFmpeg.SWScale.Converter instead.\n\nAll options supported by Membrane.FFmpeg.SWScale.Scaler are supported by Membrane.FFmpeg.SWScale.Converter.","ref":"Membrane.FFmpeg.SWScale.Scaler.html"},{"type":"module","title":"Element options - Membrane.FFmpeg.SWScale.Scaler","doc":"Passed via struct `t:Membrane.FFmpeg.SWScale.Scaler.t/0`\n\n- `output_width`  \n\n  ```\n  non_neg_integer()\n  ```\n  \n  Default value: `nil`  \n  Width of the scaled video.\n\n\n- `output_height`  \n\n  ```\n  non_neg_integer()\n  ```\n  \n  Default value: `nil`  \n  Height of the scaled video.\n\n\n\n- `use_shm?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `false`  \n  If true, native scaler will use shared memory (via `t:Shmex.t/0`) for storing frames","ref":"Membrane.FFmpeg.SWScale.Scaler.html#module-element-options"},{"type":"module","title":"Pads - Membrane.FFmpeg.SWScale.Scaler","doc":"### `:input`\n\nAccepted formats:\n```\n%RawVideo{pixel_format: :I420, aligned: true}\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\n\n\n### `:output`\n\nAccepted formats:\n```\n%RawVideo{pixel_format: :I420, aligned: true}\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:auto`","ref":"Membrane.FFmpeg.SWScale.Scaler.html#module-pads"},{"type":"function","title":"Membrane.FFmpeg.SWScale.Scaler.options/0","doc":"Returns description of options available for this module","ref":"Membrane.FFmpeg.SWScale.Scaler.html#options/0"},{"type":"type","title":"Membrane.FFmpeg.SWScale.Scaler.t/0","doc":"Struct containing options for `Membrane.FFmpeg.SWScale.Scaler`","ref":"Membrane.FFmpeg.SWScale.Scaler.html#t:t/0"},{"type":"module","title":"Membrane.FFmpeg.SWScale.Scaler.Native","doc":"This module provides natively implemented scaler utilizing library swscale.","ref":"Membrane.FFmpeg.SWScale.Scaler.Native.html"},{"type":"function","title":"Membrane.FFmpeg.SWScale.Scaler.Native.create/4","doc":"","ref":"Membrane.FFmpeg.SWScale.Scaler.Native.html#create/4"},{"type":"function","title":"Membrane.FFmpeg.SWScale.Scaler.Native.scale/3","doc":"","ref":"Membrane.FFmpeg.SWScale.Scaler.Native.html#scale/3"},{"type":"extras","title":"Membrane FFmpeg SWScale plugin","doc":"# Membrane FFmpeg SWScale plugin\n\n[![Hex.pm](https://img.shields.io/hexpm/v/membrane_ffmpeg_swscale_plugin.svg)](https://hex.pm/packages/membrane_ffmpeg_swscale_plugin)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/membrane_ffmpeg_swscale_plugin/)\n[![CircleCI](https://circleci.com/gh/membraneframework/membrane_ffmpeg_swscale_plugin.svg?style=svg)](https://circleci.com/gh/membraneframework/membrane_ffmpeg_swscale_plugin)\n\nPlugin providing an element scaling raw video frames and performing pixel format conversions, using SWScale module of [FFmpeg](https://www.ffmpeg.org/) library.\n\nIt is a part of [Membrane Multimedia Framework](https://membrane.stream).","ref":"readme.html"},{"type":"extras","title":"Installation - Membrane FFmpeg SWScale plugin","doc":"Add the following line to your `deps` in `mix.exs`. Run `mix deps.get`.\n\n```elixir\n{:membrane_ffmpeg_swscale_plugin, \"~> 0.16.2\"}\n```\n\nThe precompiled builds of the [ffmpeg](https://www.ffmpeg.org) will be pulled and linked automatically. However, should there be any problems, consider installing it manually.","ref":"readme.html#installation"},{"type":"extras","title":"Manual instalation of dependencies - Membrane FFmpeg SWScale plugin","doc":"#### macOS\n\n```shell\nbrew install ffmpeg\n```\n\n#### Ubuntu\n\n```shell\nsudo apt-get install ffmpeg\n```\n\n#### Arch / Manjaro\n\n```shell\npacman -S ffmpeg\n```","ref":"readme.html#manual-instalation-of-dependencies"},{"type":"extras","title":"Description - Membrane FFmpeg SWScale plugin","doc":"","ref":"readme.html#description"},{"type":"extras","title":"Converter - Membrane FFmpeg SWScale plugin","doc":"Converter accepts raw video in any of the pixel formats specified in type [`Membrane.RawVideo.pixel_format()`](https://hexdocs.pm/membrane_raw_video_format/Membrane.RawVideo.html#t:pixel_format/0).\nThe element requires `Membrane.RawVideo` stream format on the input with `aligned: true` constraint, meaning that each buffer must contain exactly one raw video frame.\n\n#### Converting pixel format\n\nWhen creating the element you can specify a single option `format` defining the desired pixel format of the output.\n`format` has to be [`Membrane.RawVideo.pixel_format()`](https://hexdocs.pm/membrane_raw_video_format/Membrane.RawVideo.html#t:pixel_format/0).\n\n#### Scaling\n\nConverter needs to receive stream format with input video width and height. To meet all requirements either `Membrane.RawVideo.Parser` or some decoder\n(e.g. `Membrane.H264.FFmpeg.Decoder`) have to precede Converter in the pipeline.\n\nThere are two options related to scaling, that can be specified when creating the element:\n\n- `output_width` - desired scaled video width.\n- `output_height` - desired scaled video height.\n\nBoth need to be even numbers.\n\nScaling consists of two operations:\n\n- scaling itself - resizing video frame with keeping original ratio. After that operation at least one of the\ndimensions of the input frame match the respective dimension of the desired output size. The second one\n(if does not match) is smaller than its respective dimension.\n- adding paddings - if one dimension does not match after scaling, paddings have to be added. They are put on both\nsides of the scaled frame equally. They are either above and below the frame or on the left and right sides of it.\nIt depends on the dimension that did not match after scaling.\n\nThe output of the element has the size as specified in the options.","ref":"readme.html#converter"},{"type":"extras","title":"Usage - Membrane FFmpeg SWScale plugin","doc":"Converting the pixel format of an encoded (using H.264 standard) video requires a parser and a decoder\nbecause the `SWScale.Converter` performs conversion only on the raw, decoded video. The pipeline scales the video to the `640x640`\nshape, changes the pixel format of the video to the `I422` format and reencodes it.\n\n```elixir\ndefmodule Converting.Pipeline do\n  use Membrane.Pipeline\n\n  @impl true\n  def handle_init(_ctx, _options) do\n    structure = [\n      child(:file_src, %Membrane.File.Source{location: \"/tmp/input.h264\"})\n      |> child(:parser, Membrane.H264.Parser)\n      |> child(:decoder, Membrane.H264.FFmpeg.Decoder)\n      |> child(:converter, %Membrane.FFmpeg.SWScale.Converter{\n        output_height: 640, \n        output_width: 640, \n        format: :I422\n      })\n      |> child(:encoder, Membrane.H264.FFmpeg.Encoder)\n      |> child(:file_sink, %Membrane.File.Sink{location: \"/tmp/output.h264\"})\n    ]\n    \n    {[spec: structure], %{}}\n  end\nend\n```","ref":"readme.html#usage"},{"type":"extras","title":"Copyright and License - Membrane FFmpeg SWScale plugin","doc":"Copyright 2021, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane)\n\nLicensed under the [Apache License, Version 2.0](LICENSE)","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2020 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}